$error = forceRequiredAddOn("Vehicle_Pirate_Cannon");

if($error == $Error::AddOn_Disabled)
{
	CannonTurret.uiName = "";
	cannonBallTrailEmitter.uiName = ""; //?
	CannonSmokeEmitter.uiName = ""; //?
	CannonBallProjectile.uiName = "";
}

if($error == $Error::AddOn_NotFound)
{
	error("Error: Vehicle_Player_Cannon - Required add-on Vehicle_Pirate_Cannon not found!");

	deleteVariables("$error");

	return;
}

deleteVariables("$error");

datablock PlayerData(PlayerCannonTurret : CannonTurret)
{
	uiName = "Player Cannon";

	maxItems = 0;
	maxTools = 0;
	maxWeapons = 0;
};

function PlayerCannonTurret::onDisabled(%data, %obj, %state)
{
	CannonTurret.onDisabled(%obj, %state);
}

package PlayerCannonPackage
{
	function armor::onTrigger(%data, %obj, %triggerNum, %val)
	{
		%mount = %obj.getObjectMount();

		//Hack so we can shoot if we ARE the cannon.
		if(%obj.getDataBlock().getID() == PlayerCannonTurret.getID())
		{
			if(%triggerNum == 0 && %val && !isObject(%mount = %obj.getMountedObject(0)))
			{
				if(isObject(%client = %obj.client))
				{
					commandToClient(%client, 'centerPrint', "No player to fire!", 1);
				}

				return;
			}

			%mount = %obj;
		}

		if(isObject(%mount) && (%obj == %mount || %obj.getControlObject() == %mount))
		{
			if(%mount.getDataBlock().getID() == PlayerCannonTurret.getID() && %triggerNum == 0)
			{
				if(%val == 1)
				{
					if(getSimTime() - %obj.lastShotTime < 2500)
					{
						cancel(%mount.stSched);

						return;
					}

					%mount.shotPower = 0;
					cannonStrengthLoop(%mount);

					return;
				}

				else
				{
					cancel(%mount.stSched);

					if(%mount.shotPower != 0)
					{
						playerCannonFire(%data, %obj, %triggerNum, %val, %mount);
						%mount.shotPower = 0;

						return;
					}
				}
			}
		}

		parent::onTrigger(%data, %obj, %triggerNum, %val);
	}

	function armor::onMount(%data, %obj, %col, %slot)
	{
		parent::onMount(%data, %obj, %col, %slot);

		if(%col.getDataBlock().getID() == PlayerCannonTurret.getID())
		{
			%obj.hideNode("ALL");

			if(isObject(%client = %obj.client))
			{
				serverCmdUnUseTool(%client);
			}
		}
	}

	function armor::onUnMount(%data, %obj, %col, %slot)
	{
		parent::onUnMount(%data, %obj, %col, %slot);

		if(!isObject(%col) || %slot $= "")
		{
			return;
		}

		if(%col.getDataBlock().getID() == PlayerCannonTurret.getID())
		{
			cancel(%col.stSched);
			%col.shotPower = 0;
			%col.unMountImage(2);

			%obj.unhideNode("ALL"); //Sometimes the face doesn't come back for some reason.

			if(isObject(%client = %obj.client))
			{
				%client.applyBodyParts();
			}

			else //If it's a bot.
			{
				GameConnection::applyBodyParts(%obj);
			}
		}
	}

	function serverCmdUseTool(%client, %slot)
	{
		if(isObject(%player = %client.player) && isObject(%mount = %player.getObjectMount()) && %mount.getDataBlock().getID() == PlayerCannonTurret.getID())
		{
			return;
		}

		parent::serverCmdUseTool(%client, %slot);
	}

	function gameConnection::applyBodyParts(%client)
	{
		if(isObject(%player = %client.player) && isObject(%mount = %player.getObjectMount()) && %mount.getDataBlock().getID() == PlayerCannonTurret.getID())
		{
			return;
		}

		parent::applyBodyParts(%client);
	}
};
activatepackage(PlayerCannonPackage);

function playerCannonFire(%data, %obj, %triggerNum, %val, %mount)
{
	if(isObject(%client = %obj.client))
	{
		serverCmdUnUseTool(%client);
	}

	if(getSimTime() - %obj.lastShotTime < 2500)
	{
		return;
	}

	%scaleFactor = getWord(%mount.getScale(), 2);

	if(isObject(%driver = %mount.getMountedObject(0)))
	{
		%vel = vectorScale(%mount.getMuzzleVector(0), %mount.shotPower * 5.5 * %scaleFactor);
		%driver.dismount();
		%driver.unhideNode("ALL"); //Sometimes the face doesn't come back for some reason.

		if(isObject(%driver.client))
		{
			%driver.client.applyBodyParts();
		}

		else //If it's a bot.
		{
			GameConnection::applyBodyParts(%driver);
		}

		%driver.setTransform(%mount.getEyeTransform() SPC getWords(%driver.getTransform(), 3, 5));
		%driver.setVelocity(%vel);
		%driver.burn(3000);
	}

	%mount.mountImage(CannonSmokeImage, 1);
	%mount.unMountImage(2); 

	serverPlay3D(TankshotSound, %obj.getPosition());

	%obj.lastShotTime = getSimTime();
}